/* ListDevices.c:
 *   This demo demonstrates how to enumerate multiple devices.  
 *   (c)2007-2014 Jarslav Fojtik
 */
#include <stdio.h>

#include "hudaqlib.h"


typedef struct
{
  char *DevName;
  int DevOrder;
} DeviceStruct;

int ListDevices(DeviceStruct *D)
{
int index=0;
int i,n;
HUDAQHANDLE h;
static const char *DevNames[]={"AD612","MF614","AD622","MF624","MF625","MF634",
                         "AD1753"};

  for(n=0; n<sizeof(DevNames)/sizeof(char*); n++)
    for(i=1; i<8; i++)
      {
      h = HudaqOpenDevice(DevNames[n], i, HudaqOpenNOINIT);  //Open a device
      if(h==0) break;
      HudaqCloseDevice(h);
      D[index].DevName=DevNames[n];
      D[index].DevOrder=i;
      index++;
      }  
return index;
}


int main(int argc, char* argv[])
{
int i, count;
char ch;
HUDAQHANDLE h;
DeviceStruct ds[10];

  count = ListDevices(ds);
  if(count<=0) {printf("\nNo Hudaqdevice found");return(-1);}

  if(count>1) 
    {
    for(i=0;i<count;i++)
      printf("\nPlease hit %c to choose %s card [%d]:",i+'A',ds[i].DevName,ds[i].DevOrder);
    printf("\n");
    i=toupper(getchar());
    i-='A';
    if (i<0 || i>=10) return;
    }
  else
    i=0;

  h = HudaqOpenDevice(ds[i].DevName,ds[i].DevOrder, HudaqOpenNOINIT);
  if(h==0) 
    return -3;			       /* Device cannot be openned. */    


  printf("\nDevice %s[%d] has been succesfully opened.", ds[i].DevName, ds[i].DevOrder);
  
  HudaqCloseDevice(h);                 /* Close handle */
    
return 0;
}

